/**
  ******************************************************************************
  * @file    Project/Template/stm32f10x_it.c
  * @author  MCD Application Team
  * @version V3.1.0
  * @date    06/19/2009
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
  */

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_it.h"
#include "obrazy.h"
#include <terminal.h>

/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Variables -----------------------------------------------------------------*/
u16 capture = 0;
extern vu32 CC1;
extern vu32 cnt;
extern vu32 a;
extern vu32 aa;
extern vu8 b;
extern vu8 c;
extern vu8 d;
extern vu8 k;
extern vu8 z;

extern vu8 smerfy[3][96][6];
extern vu8 map[3][96][6];
extern vu8 map1[3][96][6];
extern vu8 map2[3][96][6];
extern vu8 map3[3][96][6];
extern vu8 map4[3][96][6];
extern vu8 map5[3][96][6];
extern vu8 obeliks[3][96][6];

//extern vu8 mapka[80][5];
extern vu32 cntcnt;
extern vu16 cnt1, cnt2, cnt3, cnt4, cnt5, cnt6;
uint8_t TxBuf[3]={0, 0x0D, 0};
uint8_t TxIndex;
extern vu8 RxBuf[];
extern vu8 RxIndex;
extern vu8 odebrano_polecenie;
extern vu8 czerwony;
extern vu8 zielony;
extern vu8 niebieski;
extern vu8 obraz;
extern vu8 anim;
extern vu8 stan;
extern vu8 przesuniecie;
extern vu8 p;
extern vu8 obrot;
vu32 cntbuf;
extern void obrazek();
extern void brak();
extern void ocean();



/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
}

/******************************************************************************/
/*                 STM32F10x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f10x_xx.s).                                            */
/******************************************************************************/

void TIM2_IRQHandler(void)						//przerwanie od czujnika
{
  if (TIM_GetITStatus(TIM2, TIM_IT_CC2) == SET)	 // Jezeli przerwanie od kanalu 2
  {
    TIM_ClearITPendingBit(TIM2, TIM_IT_CC2);	 // Zeruj flage przerwania


    cnt = TIM_GetCapture2(TIM2);				 // Odczytaj wartosc rejetru CCR kanalu 2

    if (cnt>2500){
    	cntbuf=cnt;
    	CC1 = (uint32_t) cntbuf / 96 ;								//Warto do jakiej zliczac ma timer1
    }
    else
    	CC1 = (uint32_t) cntbuf / 96 ;								//Warto do jakiej zliczac ma timer1

    aa++;										//zmienna do animacji

   	//p++;										//zienna pomocnicza do przesuniecia

    if (obrot)
    {
    	przesuniecie++;

    	if (przesuniecie > 95)	przesuniecie = 0;

    	c=0+przesuniecie;
    }

    else
    {
    	c=0;
    }

   // c=0;


   // if (c > 95)
    //	c = 0 + przesuniecie;


    TIM_SetCounter(TIM2, 0);   					 // Zeruj licznik TIM2

	/*	if (aa%15==0)
	    {
	    	TxBuf[0]=(uint8_t)(50000/cnt);
			//TxBuf[0]=30;
			//TxBuf[1]=55;
	    	USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
	    }
*/
    Usart_SendC(USART1, 50000/cntbuf);

    TIM_SetCompare1(TIM1, TIM_GetCapture1(TIM1) + CC1);
  }
}

void TIM1_CC_IRQHandler(void)					//Przerwanie od timer1
{
  	if (TIM_GetITStatus(TIM1, TIM_IT_CC1) != RESET)
  	{
    	TIM_ClearITPendingBit(TIM1, TIM_IT_CC1);	// Zeruj flage przerwania

    	TIM_SetCompare1(TIM1, TIM_GetCapture1(TIM1) + CC1);	//Zeruj licznik TIM1

    	//a++;
    	//if (a>3)
    	//{
    //		a=0;

    //	}


//-------------------------wyswietlanie 1 lini-----------------------------



    	if (obraz && !anim)
    	{
			switch(obraz)
			{
			case 1:

				obrazek(smerfy);

			break;

			case 2:

				obrazek(map);

			break;

			case 3:

				obrazek(map1);

			break;
				case 4:

					obrazek(map2);

			break;
			case 5:

					obrazek(map3);

			break;
			case 6:

					obrazek(map4);

			break;
			case 7:

					obrazek(map5);

			break;
			case 8:

					obrazek(smerfy);

			break;
				case 9:

					obrazek(obeliks);

				break;
			}
    	}
    	else if (anim && !obraz)
    	{
			switch(stan)
			{
				case 1:

					ocean();

				break;

				case 2:

					obrazek(map);

				break;

				case 3:

					obrazek(map1);

				break;
				case 4:

					obrazek(map2);

				break;
				case 5:

					obrazek(map3);

				break;
				case 6:

					obrazek(map4);

				break;
				case 7:

					obrazek(map5);

				break;

			}
    	}

		c++;
		if (c>95) c=0;
  	}

}

void USART1_IRQHandler(void)
{
  	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
  	{
    	RxBuf[RxIndex++] = USART_ReceiveData(USART1);

		if(RxBuf[RxIndex-1] == 0x0D)
		{
			odebrano_polecenie = 1;
			RxIndex = 0;
		}
  	}

  	if(USART_GetITStatus(USART1, USART_IT_TXE) != RESET)
  	{
    	USART_SendData(USART1, TxBuf[TxIndex++]);

    	if(TxBuf[TxIndex-1] == 0x0D)
    	{
      		USART_ITConfig(USART1, USART_IT_TXE, DISABLE);
			TxIndex = 0;
    	}
  	}
}

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
