
#include <stm32f10x_usart.h>
#include <string.h>
#include "terminal.h"
#include <stdlib.h>
//#include <stdio.h>

//extern vu8 *TxBuf[];
static void __reverse(char* begin,char* end);


// aby mie polskie ogonki w PUTTY ----> ustawi WINDOW / Translation / Win1250

//const char UCLS[]= { "\x1b""[2J""\n" };
char UCLS[]= { "\x1b""[2J"};

char UHOME[] = { "\x1b""[;H" };

char UCUR_HIDE[] = { "\x1b""[?25l" };
char UCUR_SHOW[]  = { "\x1b""[?25h" };

char U_ATTR_OFF[] = { "\x1b""[m" };

void Usart_SendC(USART_TypeDef* USARTx, uint16_t Data){
	while(!USART_GetFlagStatus(USARTx, USART_FLAG_TXE));
	USART_SendData(USARTx, Data);
}

void Usart_SendS(USART_TypeDef* USARTx, char *s){
	register char c;
	while ((c = *s++)){
		Usart_SendC(USARTx, c);
	}
}

void Usart_SendInt(USART_TypeDef* USARTx, int value, int radix){
	char string[17];
	itoa(value, string, radix);
	Usart_SendS(USARTx, string);

}

void tr_cursor_hide(USART_TypeDef* USARTx, uint8_t hide ) {
	if(hide) Usart_SendS(USARTx, UCUR_HIDE );
	else Usart_SendS(USARTx, UCUR_SHOW );
}


void tr_cls(USART_TypeDef* USARTx, uint8_t cur_onoff) {

	Usart_SendS(USARTx, U_ATTR_OFF );
	tr_cursor_hide( USARTx, cur_onoff);
	Usart_SendS(USARTx, UCLS );

	Usart_SendS(USARTx, UHOME );

}


void fill_line(USART_TypeDef* USARTx, char ascii, uint8_t cnt ) {
	uint8_t i;
	for( i=0; i<cnt; i++) Usart_SendC(USARTx, ascii );
}


void tr_attr(USART_TypeDef* USARTx, uint8_t atr, uint8_t fg, uint8_t bg ) {
	Usart_SendC(USARTx, 0x1b );		// <ESC>[0;32;44m
	Usart_SendC(USARTx, '[' );
	Usart_SendC(USARTx, atr+'0' );
	Usart_SendC(USARTx, ';' );
	Usart_SendC(USARTx, '3' );
	Usart_SendC(USARTx, fg+'0' );
	Usart_SendC(USARTx, ';' );
	Usart_SendC(USARTx, '4' );
	Usart_SendC(USARTx, bg+'0' );
	Usart_SendC(USARTx, 'm' );
}


void tr_pen_color(USART_TypeDef* USARTx, uint8_t cl ) {
	Usart_SendC(USARTx, 0x1b );		// <ESC>[34m
	Usart_SendC(USARTx, '[' );
	Usart_SendC(USARTx, '3' );
	Usart_SendC(USARTx, cl+'0' );
	Usart_SendC(USARTx, 'm' );
}

void tr_brush_color(USART_TypeDef* USARTx, uint8_t cl ) {
	Usart_SendC(USARTx, 0x1b );		// <ESC>[44m
	Usart_SendC(USARTx, '[' );
	Usart_SendC(USARTx, '4' );
	Usart_SendC(USARTx, cl+'0' );
	Usart_SendC(USARTx, 'm' );
}


void tr_locate(USART_TypeDef* USARTx, uint8_t y, uint8_t x ) {

	Usart_SendC(USARTx, 0x1b );	// <ESC>[y;xH
	Usart_SendC(USARTx, '[' );
	Usart_SendInt(USARTx, y, 10 );
	Usart_SendC(USARTx, ';' );
	Usart_SendInt(USARTx, x, 10 );
	Usart_SendC(USARTx, 'H' );
}

char* itoa(int value, char* buffer, int base)
{
	static const char digits[]="0123456789abcdef";

	char* buffer_copy=buffer;
	int32_t sign=0;
	int32_t quot,rem;

	if ((base>=2)&&(base<=16))				// is the base valid?
	{
		if (base == 10 && (sign = value) < 0)// negative value and base == 10? store the copy (sign)
			value = -value;					// make it positive

		do
		{
			quot=value/base;				// calculate quotient and remainder
			rem=value%base;
			*buffer++ = digits[rem];		// append the remainder to the string
		} while ((value=quot));				// loop while there is something to convert

		if (sign<0)							// was the value negative?
			*buffer++='-';					// append the sign

		__reverse(buffer_copy,buffer-1);		// reverse the string
	}

	*buffer='\0';
	return buffer_copy;
}


static void __reverse(char* begin,char* end)
{
	char temp;

	while (end>begin)
	{
		temp=*end;
		*end--=*begin;
		*begin++=temp;
	}
}
